<template>
  <div>
    <Modal v-model="showEditModal" v-drag :mask-closable="true" width="1000px">
      <p slot="header">
        {{ modalTitle }}
      </p>
      <div>
        <Form
          id="right-edit-form-edit"
          ref="formObj"
          :model="formObj"
          :rules="ruleValidate"
          :label-width="80"
          inline
        >
          <Form-item label="调查项目" prop="investigateItem" class="width-48">
            <Input
              v-model="formObj.investigateItem"
              name="investigateItem"
              placeholder="请选择调查项目"
              icon="plus-circled"
              readonly
              @click.native="_selectZtree"
            /></Input>
          </Form-item>
          <Form-item label="调查标准" prop="investigateStandard" class="width-48">
            <Tooltip content="长度为0-100" placement="bottom-start">
              <Input
                v-model="formObj.investigateStandard"
                name="investigateStandard"
                :maxlength="100"
                placeholder="请输入调查标准"
                style="width:230px;"
              /></Input>
            </Tooltip>
          </Form-item>
          <Form-item label="客户评判标准" prop="customerStandard" class="width-48">
            <Select v-model="formObj.customerStandard" clearable placeholder="请输入客户评判标准">
              <Option v-for="item in standardList" :key="item.name" :value="item.name">
                {{ item.name }}
              </Option>
            </Select>
          </Form-item>
          <Form-item label="说明" prop="remark" class="width-48">
            <Input v-model="formObj.remark" name="remark" placeholder="请输入说明" style="width: 230px" :maxlength="100" /></Input>
          </Form-item>
        </form>
      </div>
      <div slot="footer">
        <modal-footer ref="footerModal" :footer="footerList" @on-result-change="_footerResult" />
      </div>
    </Modal>

    <!--选择人员-->
    <UserInfo ref="userModal" is-change @on-result-change="_userData" />
    <!--选择上级菜单tree-->
    <selectResourceTree ref="treeModal" @on-result-change="_treeData" />
  </div>
</template>
<script>
/**
 * 添加编辑
 */
import { dict, staffInfo, customerInvestigateDetail } from '../../../api'
import UserInfo from '../../../components/user-info-single/assignPerson'
import selectResourceTree from '../customer-satisfied-item/tree/selectEquipLocationTree'
export default {
  components: { UserInfo, selectResourceTree },
  data: function() {
    return {
      id: '',
      modalTitle: '添加',
      formObj: {
        investigateId: undefined,
        investigateItem: undefined,
        investigateStandard: undefined,
        customerStandard: undefined,
        remark: ''
      },
      standardList: [],
      innerAuditList: [],
      userList: [],
      ruleValidate: {
        trainTopic: [
          { required: true, message: '培训主题不能为空', trigger: 'blur' }
        ],
        trainId: [
          { required: true, message: '所属培训计划不能为空', trigger: 'change' }
        ]
      },
      showEditModal: false,
      footerList: [
        { id: '', name: '取消', type: '' },
        { id: '', name: '确定', type: 'primary' }
      ]
    }
  },
  methods: {
    // modal
    _footerResult(name) {
      switch (name) {
        case '取消':
          this._cancel()
          break
        case '确定':
          this._ok()
          break
      }
    },
    _hideLoading() {
      this.$refs.footerModal._hideLoading()
    },
    _resultChange(result, msg) {
      if (result) {
        this.showEditModal = false
        this.$Message.success(msg)
        this.$emit('on-result-change')
      }
      this._hideLoading()
    },
    _selectApply() {
      this.$refs.userModal._open('registerName')
    },
    _userData(data, msg) {
      // 选择人员返回数据
      if (msg === 'registerName') {
        // 选择取样人取样人
        this.formObj.registerName = data.realname
        this.formObj.registerId = data.userId
      }
    },
    // 选择tree
    _selectZtree() {
      this.$refs.treeModal._open()
    },
    _treeData(result) {
      if (result === undefined) {
        this.formObj.investigateItem = ''
      } else {
        this.formObj.investigateItem = result.name
      }
    },
    _getStandardList: async function() {
      const result = await dict.getItem('客户评判标准')
      this.standardList = result
    },
    _selectPlan() {
      this.$refs.trainPlanModal._open()
    },

    _backTrainPlanData(data) {
      this.formObj.trainPlan = data.name
      this.formObj.trainId = data.id
    },
    _ok() {
      this.$refs.formObj.validate(valid => {
        if (valid) {
          this._save(this.formObj)
        } else {
          this.$Message.error('表单验证失败')
          this._hideLoading()
        }
      })
    },

    _checkMemberNameChange(data) {
      this.formObj.checkMemberName = data.label.trim()
      this.formObj.checkMemberId = data.value.trim()
    },
    // 添加、编辑保存
    _save: async function(data) {
      if (data.id === undefined || data.id === '') {
        const result = await customerInvestigateDetail.add(data)
        this._resultChange(result, '添加成功')
      } else {
        const result = await customerInvestigateDetail.edit({
          id: data.id,
          obj: data
        })
        this._resultChange(result, '编辑成功')
      }
    },
    _cancel() {
      this.showEditModal = false
    },
    _getUserList: async function() {
      const result = await staffInfo.list({ status: 1 })
      if (result) {
        this.userList = result
      }
    },
    _leaderChange(obj) {
      console.log(obj)
      if (obj) {
        this.formObj.checkGroupLeaderName = obj.label.trim()
      } else {
        this.formObj.checkGroupLeaderName = ''
      }
    },

    _memberChange(obj) {
      let names = ''
      let ids = ''
      obj.forEach(function(item) {
        names = names + item.label.trim() + ','
        ids = ids + item.value + ','
      })
      this.formObj.checkGroupMemberNames = names.substring(0, names.length - 1)
      this.formObj.checkGroupMemberIds = ids.substring(0, ids.length - 1)
    },
    _open(investigateId, formObj) {
      this.$refs.formObj.resetFields()
      this.formObj.investigateId = investigateId
      this.showEditModal = true
      this._hideLoading()
      this._getStandardList()
      if (formObj === '') {
        this.id = ''
        this.modalTitle = '添加内审实施管理'
      } else {
        this.id = formObj.id
        this.formObj = formObj
        this.modalTitle = '编辑内审实施管理'
        if (undefined !== formObj.checkManageTime) {
          this.formObj.checkManageTime = this.$dateformat(
            new Date(formObj.checkManageTime),
            'yyyy-mm-dd'
          )
        } else {
          this.formObj.checkManageTime = ''
        }
        if (undefined !== formObj.ctime) {
          this.formObj.ctime = this.$dateformat(
            new Date(formObj.ctime),
            'yyyy-mm-dd'
          )
        } else {
          this.formObj.ctime = ''
        }
      }
    }
  }
}
</script>
